; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
; NOTE:
; Previous my testings I complete with NOT-CASE-TOLERANT Lingo's proc.
; In this test, I use new Lingo's proc, which is case tolerant, as my (Alex's - Axhex2dw)
; So, please, test it, and say me timings.
; You may change the string length, or its case, and see results and timings also.
;
; And, if I don't bothered to you, comment next macro, and test also:
UseFastestVariant EQU 1
; If this macro is defined, used more speedy and slightly longer Axhex2dw proc,
; if macro is not defined, used shortes and slightly slower proc.

.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axa2l   proto :dword 
z_htodw PROTO :DWORD

Axhex2dw_Unrolled PROTO:DWORD
hex2binSSE2	PROTO:DWORD

.data

align  16
hexstring    db  "aB2dEf01",0

;align 16
;numstring          db  "1234543210",0
;align 16
;negnumstring   db  "-1234543210",0

.code
start:

	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	
	print "Test with case-insensitive variant of Lingo's hex2dword algo",13,10
	print "with using simple string in .data section (not in the end of the buffer).",13,10,13,10
	

	REPEAT 3
		invoke Sleep, 200
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke l_htodw, addr  hexstring
		counter_end
		print str$(eax), 9, "cycles for  l_htodw - Lingo", 13, 10
	
		invoke Sleep, 200
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
			invoke Axhex2dw_Unrolled, addr  hexstring
		counter_end
		print str$(eax), 9, "cycles for  Axhex2dw Unrolled - Alex", 13, 10
	
		invoke Sleep, 200
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
			invoke hex2binSSE2, addr  hexstring
		counter_end
		print str$(eax), 9, "cycles for  hex2binSSE2 - Jochen", 13, 10
	
		print " ",13,10,13,10
	ENDM
	

	print " ", 13, 10
	print "Codesizes:", 13, 10
	print "l_htodw - Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw
	print str$(eax), 13, 10

	print "Axhex2dw Unro - Alex:", 9
	mov   eax, Axhex2dw_endp_Unrolled
	sub	  eax, Axhex2dw_Unrolled
	print str$(eax), 13, 10
	
	print "Axhex2dw - Alex:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

	print "hex2binSSE2 - Jochen:", 9
	mov   eax, hex2binSSE2_endp
	sub	  eax, hex2binSSE2_s
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	
align 16
l_htodw   proc lpString:dword
mov         edx, [esp+1*4]
push		ebx
mov         ebx, [edx]
xor           ecx, ecx 	
add          cl,    bl
je       		End1
mov         eax, [tabl8+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    bh
je       		End2
mov			edx, [edx+4]
add          eax, [tabl7+ecx*4-0C0h] 
xor           ecx, ecx 	
shr			ebx, 16
add          cl,    bl
je       		End3
add          eax, [tabl6+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    bh
je       		End4
add          eax, [tabl5+ecx*4-0C0h] 
xor           ecx, ecx 	
add          cl,    dl
je       		End5
add          eax, [tabl4+ecx*4-0C0h] 
xor			ecx, ecx 	
add          cl,    dh
je       	    End6
add          eax, [tabl3+ecx*4-0C0h] 
pop         ebx 
shr			edx, 16
xor           ecx, ecx 	
add          cl,    dl
je       	    End7
add          eax, [tabl2+ecx*4-0C0h] 
xor           ecx, ecx 	
add           cl,    dh
je       	     End8
add           eax, [tabl1+ecx*4-0C0h] 
ret			 4
align 16
End1:
pop			 ebx
ret		 	 4
align 16
End2:
shr			 eax, 28
pop			 ebx
ret 4
align 16
End3:
shr			 eax, 24
pop			 ebx
ret 4
align 16
End4:
shr			 eax, 20
pop			 ebx
ret 4
align 16
End5:
shr			 eax, 16
pop			 ebx
ret 4
align 16
End6:
shr			 eax, 12
pop			 ebx
ret 4
align 16
End7:
shr			 eax, 8
ret 4
align 16
End8:
shr			 eax, 4
ret 4
align 16
tabl1  dd   0,1,2,3,4,5,6,7,8,9
		  dd 	  7 Dup(0)
          dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
		  dd   26	Dup(0) 
		  dd   0Ah, 0Bh,0Ch,0Dh,0Eh,0Fh
align 16
tabl2  dd   0,1*10h,2*10h,3*10h,4*10h,5*10h,6*10h,7*10h,8*10h,9*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h, 0Bh*10h,0Ch*10h,0Dh*10h,0Eh*10h,0Fh*10h
align 16
tabl3  dd   0,1*10h*10h,2*10h*10h,3*10h*10h,4*10h*10h,5*10h*10h,6*10h*10h,7*10h*10h,8*10h*10h,9*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h, 0Bh*10h*10h,0Ch*10h*10h,0Dh*10h*10h,0Eh*10h*10h,0Fh*10h*10h
align 16
tabl4  dd   0,1*10h*10h*10h,2*10h*10h*10h,3*10h*10h*10h,4*10h*10h*10h,5*10h*10h*10h,6*10h*10h*10h,7*10h*10h*10h,8*10h*10h*10h,9*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h*10h, 0Bh*10h*10h*10h,0Ch*10h*10h*10h,0Dh*10h*10h*10h,0Eh*10h*10h*10h,0Fh*10h*10h*10h
align 16
tabl5  dd   0,1*10h*10h*10h*10h,2*10h*10h*10h*10h,3*10h*10h*10h*10h,4*10h*10h*10h*10h,5*10h*10h*10h*10h,6*10h*10h*10h*10h,7*10h*10h*10h*10h,8*10h*10h*10h*10h,9*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
		  dd   26	Dup(0) 
		  dd   0Ah*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h,0Ch*10h*10h*10h*10h,0Dh*10h*10h*10h*10h,0Eh*10h*10h*10h*10h,0Fh*10h*10h*10h*10h
align 16
tabl6  dd   0,1*10h*10h*10h*10h*10h, 2*10h*10h*10h*10h*10h, 3*10h*10h*10h*10h*10h
           dd  4*10h*10h*10h*10h*10h, 5*10h*10h*10h*10h*10h, 6*10h*10h*10h*10h*10h, 7*10h*10h*10h*10h*10h, 8*10h*10h*10h*10h*10h, 9*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
          dd   0Ah*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h
align 16
tabl7 dd   0,1*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h 
          dd 4*10h*10h*10h*10h*10h*10h,5*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
           dd   0Ah*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h
align 16
tabl8  dd    0,1*10h*10h*10h*10h*10h*10h*10h,2*10h*10h*10h*10h*10h*10h*10h,3*10h*10h*10h*10h*10h*10h*10h,4*10h*10h*10h*10h*10h*10h*10h 
           dd   5*10h*10h*10h*10h*10h*10h*10h,6*10h*10h*10h*10h*10h*10h*10h,7*10h*10h*10h*10h*10h*10h*10h,8*10h*10h*10h*10h*10h*10h*10h,9*10h*10h*10h*10h*10h*10h*10h
		  dd 	  7 Dup(0)
          dd   0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
		  dd   26	Dup(0) 
          dd   0Ah*10h*10h*10h*10h*10h*10h*10h, 0Bh*10h*10h*10h*10h*10h*10h*10h,0Ch*10h*10h*10h*10h*10h*10h*10h,0Dh*10h*10h*10h*10h*10h*10h*10h,0Eh*10h*10h*10h*10h*10h*10h*10h,0Fh*10h*10h*10h*10h*10h*10h*10h
l_htodw  endp
l_htodw_endp:


align 16

db 0CCh,0CCh,0CCh,0CCh ; shifting to align main loop at 16 bytes
Axhex2dw    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	xor eax,eax
	mov [esp+4],edi
	
	jmp @preloop
	
	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	add edx,1
	shl eax,4
	lea edi,[edi+ecx*8]
	add eax,ecx
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw    endp
Axhex2dw_endp:


align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	.data
	align 16
	@table label UNIT
	;UNIT 30h dup (-1)
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
	.code _TEXT
		
Axhex2dw_Unrolled    endp
Axhex2dw_endp_Unrolled:

align 16
jq1	dq	3939393939393939h, 0	; 8* "9"
jq2	dq	0707070707070707h, 0	; 8* 7
jq3	dq	3030303030303030h	; 8* "0"

hex2binSSE2_s:
hex2binSSE2 proc src
	push esi
	push ecx	; preserves ecx
	mov esi, [esp+12]
	mov edx, offset jq1
	movlps xmm0, qword ptr [esi]
	movdqa xmm1, xmm0
	pcmpgtb xmm1, [edx+0]	; jq1 - get info which items are letters
	pand xmm1, [edx+16]	; jq2 - prepare for subtracting extra 7
	paddb xmm1, [edx+32]	; jq3 - load either 30h or 37h
	psubb xmm0, xmm1	; subtract from bytes in string
	movd ecx, xmm0	; ecx: 0d0c0b0a
	pshufd xmm0, xmm0, 01b	; swap lower dwords
	movd edx, xmm0	; edx: 08070f0e
	if 0		; 56 cycles on Prescott
		bswap ecx
		mov eax, ecx
		shr ecx, 4
		add al, cl
		shr ecx, 4
		mov ah, ch
		shr ecx, 4
		add ah, ch
		ror eax, 16
		bswap edx
		mov al, dl
		shr edx, 4
		add al, dl
		shr edx, 4
		mov ah, dh
		shr edx, 4
		add ah, dh
	elseif 0
		bswap ecx	; have fun here with your own version
		mov eax, ecx
		shr ecx, 4
		add al, cl
		shr ecx, 4
		mov ah, ch
		shr ecx, 4
		add ah, ch
		ror eax, 16
		bswap edx
		mov al, dl
		shr edx, 4
		add al, dl
		shr edx, 4
		mov ah, dh
		shr edx, 4
		add ah, dh
	elseif 1	; 60 cycles on Prescott
		rol ecx, 8
		movzx eax, byte ptr cl
		rol ecx, 12
		add al, cl
		rol ecx, 4
		mov ah, cl
		rol ecx, 12
		add ah, cl
		ror eax, 16
		rol edx, 8
		mov al, dl
		rol edx, 12
		add al, dl
		rol edx, 4
		add ah, dl
		rol edx, 12
		add ah, dl
	endif
	pop ecx
	pop esi
	ret 4
hex2binSSE2 endp
hex2binSSE2_endp:

option prologue:prologuedef
option epilogue:epiloguedef

end start

OPT_Tmp2Asm	1
